// labels on barcodes

#include "fivewin.ch"

#command RELEASE <ClassName> <oObj1> [,<oObjN>]                         ;
                                                                        ;
      => <oObj1>:End() [; <oObjN>:End()]

function barlen13(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
    local oFont, nLenChar, l ,Control,k,n,nWidthChar

    default lHorz := .t.

    default nWidth := 0.025 // 1/3 M/mm

    default nLen := 1.5 // Cmm.

    default cFont := 'arial'

    default Color := CLR_BLACK

    k:=left(alltrim(cCode)+'000000000000',12) // padding with '0'
	// calculo del digito de control
     k:=k+EAN13_CHECK(k)                           // Chaeck Digit en EAN13
    if !lHorz
        nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end
    // Len of bar
    if lHorz
        nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end

    define font oFont name cFont of oPrint size nWidth*5.6 , nLen*0.08 ;
                nescapement if(lHorz,0,13500)

    if lHorz
        oPrint:say(nRow+nLen*0.9,nCol-nWidth*8,left(k,1),oFont,,Color)
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*3,substr(k,2,6),oFont,,Color)
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*50,substr(k,8,6),oFont,,Color)
    else
        oPrint:say(nRow-nWidth*8,nCol+nLen*0.1,left(k,1),oFont,,Color)
        oPrint:say(nRow+nWidth*3,nCol+nLen*0.1,substr(k,2,6),oFont,,Color)
        oPrint:say(nRow+nWidth*50,nCol+nLen*0.1,substr(k,8,6),oFont,,Color)
    end
    release font oFont
return nil



function barlen(cCode,nDigs,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
    local oFont, nLenChar, l ,Control,k,s1,s2,n, Izda, dCha

    default lHorz := .t.

    default nWidth := 0.025 // 1/3 M/mm

    default nLen := 1.5 // Cmm.

    default cFont := 'arial'

    default Color := CLR_BLACK

    default nDigs := 11

	// calculo del digito de control
    k:=left(alltrim(cCode)+'000000000000',nDigs) // padding with '0'
	// calculo del digito de control
    k=k+Upc_CHECK(cCode,nDigs)                     // cCode,nLen
    nDigs++
    dcha:=Right(K,nDigs/2)
    izda:=Left(k,nDigs/2)

    if !lHorz
        nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end
    // Len of bar
    if lHorz
        nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end

    define font oFont name cFont of oPrint size nWidth*5.6 , nLen*0.04 ;
                nescapement if(lHorz,0,13500)



    // fisrt letter

    if lHorz
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*3,Izda,oFont,,Color)
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*(int(nDigs)/2*7+8),dcha,oFont,,Color)
    else
        oPrint:say(nRow+nWidth*3,nCol+nLen*0.1,izda,oFont,,Color)
        oPrint:say(nRow+nWidth*(nDigs/2+8),nCol+nLen*0.1,dcha,oFont,,Color)
    end
    release font oFont
return nil


function ban5(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
    local oFont, nLenChar, k,n, oPen

    default lHorz := .t.

    default nWidth := 0.025 // 1/3 M/mm

    default nLen := 1.5 // Cmm.

    default cFont := 'arial'

    default Color := CLR_BLACK

    ccode:=left(alltrim(cCode)+'000000000000',5) // padding with '0'

    if !lHorz
        nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end
    // Len of bar
    if lHorz
        nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end



    define font oFont name cFont of oPrint size nWidth*5.6 , nLen*0.04 ;
                nescapement if(lHorz,0,13500)

    define pen oPen color CLR_WHITE of oPrint

    k:=''
    for n:=1 to 4
        k+=substr(cCode,n,1)+ ' '
    end
    cCode := k+right(cCOde,1)

    if lHorz
        oPrint:box(nrow,ncol,nrow+nLen*.3,nCol+48*nWidth,oPen)
    else
        oPrint:box(nrow,ncol,nrow+41*nWidth,nCol+nLen*.3+48*nWidth,oPen)
    end
    oPrint:say(nRow,nCol,cCode,oFont,,Color)
    release font oFont
    release pen oPen
return nil


function UPCA_barlen(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
    local oFont, nLenChar, l ,Control,k,n, Izda, dCha, nDigs:=11,oFont2

    default lHorz := .t.

    default nWidth := 0.025 // 1/3 M/mm

    default nLen := 1.5 // Cmm.

    default cFont := 'arial'

    default Color := CLR_BLACK


	// calculo del digito de control
    k:=left(alltrim(cCode)+'000000000000',nDigs) // padding with '0'
	// calculo del digito de control
    k=k+Upc_CHECK(cCode,nDigs)                     // cCode,nLen
    nDigs++
    dcha:=Right(K,nDigs/2)
    izda:=Left(k,nDigs/2)

    if !lHorz
        nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end
    // Len of bar
    if lHorz
        nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
    else
       nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
    end

    define font oFont name cFont of oPrint size nWidth*5.6 , nLen*0.04 ;
                nescapement if(lHorz,0,13500)
    define font oFont2 name cFont of oPrint size nWidth*5.6 , nLen*0.025 ;
                nescapement if(lHorz,0,13500)



    // fisrt letter

    if lHorz
        oPrint:say(nRow+nLen*0.9,nCol-nWidth*8,left(k,1),oFont2,,Color)
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*10,right(Izda,5),oFont,,Color)
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*50,left(dcha,5),oFont,,Color)
        oPrint:say(nRow+nLen*0.9,nCol+nWidth*95,right(k,1),oFont2,,Color)

    else
        oPrint:say(nRow-nWidth*8,nCol+nLen*0.1,left(k,1),oFont2,,Color)
        oPrint:say(nRow+nWidth*10,nCol+nLen*0.1,right(izda,5),oFont,,Color)
        oPrint:say(nRow+nWidth*50,nCol+nLen*0.1,left(dcha,5),oFont,,Color)
        oPrint:say(nRow+nWidth*95,nCol+nLen*0.1,right(k,1),oFont2,,Color)

    end
    release font oFont
return nil


