// genera codigo ean13
static derecha:=[1110010110011011011001000010101110010011101010000100010010010001110100]
static izda1:=  [0001101001100100100110111101010001101100010101111011101101101110001011]
static izda2:=  [0100111011001100110110100001001110101110010000101001000100010010010111]
static primero:=[ooooooooeoeeooeeoeooeeeooeooeeoeeooeoeeeoooeoeoeoeoeeooeeoeo]
#include "common.ch"

function _ean13( cCode )
   local l,s1,s2,controln,ac,cad,cadena,cadena2, n1, n2, NUmero
   local Izda, Dcha, String, Mascara, k  ,n
   k:=left(alltrim(cCode)+'000000000000',12)     // padding with '0'
   // calculo del digito de control
   k:=k+EAN13_CHECK(k)                           // Chaeck Digit en EAN13
   // preparacion de la cadena de impresion
   cadena:=[]
   dcha:=SUBSTR(K,8,6)
   izda:=substr(k,2,6)
   mascara:=substr(primero,(val(substr(k,1,1))*6)+1,6)
   *  ? mascara
   // barra de delimitacion
   cadena:=[101]
   // parte izda
   for n=1 to 6
      numero:=val(substr(izda,n,1))
      if substr(mascara,n,1)=[o]
         string:=substr(izda1,numero*7+1,7)
      else
         string:=substr(izda2,numero*7+1,7)
      end
      *  ? strzero(numero,1)+[->]+string
      cadena:=cadena+string

   next
   cadena:=cadena+[01010]
   // LADO DERECHO
   for n=1 to 6
      numero:=val(substr(dcha,n,1))
      string:=substr(derecha,numero*7+1,7)
      *  ? strzero(numero,1)+[->]+string
      cadena:=cadena+string
   next
   cadena:=cadena+[101]
   *  ? cadena
   *  cadena:=cadena+[101]
return Cadena

*-- FUNCTION -----------------------------------------------------------------
*       Nombre: EAN13_CHECK()          Docs: Cayetano Gomez
*  Descripcion: Ean13, check Digit
*        Autor: Cayetano Gomez
*       Creado: 9/06/97                 Actualizado: 9/06/97
*         Hora: 11:40:36                      Hora: 11:40:36
*    Copyright: C.G.R.
*-----------------------------------------------------------------------------
*    Argumentos: cCode
*       Retorna: nil
*   Relacionado:
*-----------------------------------------------------------------------------
FUNCTION EAN13_CHECK(cCode)
   local s1,s2,l,Control,n
   s1:=0                                         // suma de impares
   s2:=0                                         // suma de pares
   for n=1 to 6
      s1:=s1+val(substr(cCode,(n*2)-1,1))
      s2:=s2+val(substr(cCode,(n*2),1))
   next
   control:=(s2*3)+s1
   l:=10
   do while control>l
      l:=l+10
   end
   control:=l-control

RETURN sTr(control,1,0)


function _ean13BL(nLen)
   default nLen to 12
   nLen:=int(nLen/2)
return '101'+replicate('0',nLen*7)+'01010'+replicate('0',nLen*7)+'101'


function _UPC( cCode, nLen )
   local l,s1,s2,control,n,ac,cad,cadena, n1, n2, NUmero
   local Izda, Dcha, String, Mascara, k
   default nLen to 11
   default cCode to '0'
   // valid values for nLen are 11,7
   k:=left(alltrim(cCode)+'000000000000',nLen)   // padding with '0'
   // calculo del digito de control
   k=k+Upc_CHECK(cCode,nLen)                     // cCode,nLen
   nLen++
   // preparacion de la cadena de impresion
   cadena:=[]
   dcha:=Right(K,nLen/2)
   izda:=Left(k,nLen/2)
   // barra de delimitacion
   cadena:=[101]
   // parte izda
   for n=1 to len(Izda)
      numero:=val(substr(izda,n,1))
      cadena+=substr(izda1,numero*7+1,7)
   next
   cadena:=cadena+[01010]
   // LADO DERECHO
   for n=1 to len(dcha)
      numero:=val(substr(dcha,n,1))
      cadena+=substr(derecha,numero*7+1,7)
   next
   cadena:=cadena+[101]
return Cadena

function _UPCABL(cCode)
   local cadena, k
   k:=left(alltrim(cCode)+'000000000000',11)   // padding with '0'
   // calculo del digito de control
   k=k+Upc_CHECK(cCode,11)                     // cCode,nLen
   // preparacion de la cadena de impresion
   cadena:=[101]
   // parte izda
      cadena+=substr(izda1,val(left(k,1))*7+1,7)
      cadena+=replicate('0',35) // resto
   cadena:=cadena+[01010] //centro
   // LADO DERECHO
      cadena+=replicate('0',35) // resto
      cadena+=substr(derecha,val(right(k,1))*7+1,7)
   cadena:=cadena+[101]
return Cadena

*-- FUNCTION -----------------------------------------------------------------
*       Nombre: Upc_CHECK()            Docs: Cayetano Gomez
*  Descripcion: ChechDigit del UPC
*        Autor: Cayetano Gomez
*       Creado: 9/06/97                 Actualizado: 9/06/97
*         Hora: 11:47:09                      Hora: 11:47:09
*    Copyright: C.G.R.
*-----------------------------------------------------------------------------
*    Argumentos: cCode
*             : nLen, Numero de digitoss ( 11 o 7)
*       Retorna: Cadena
*   Relacionado:
*-----------------------------------------------------------------------------
Function Upc_CHECK(cCode,nLen)
   local s1,s2,n,l,control
   s1:=0                                         // suma de impares
   s2:=0                                         // suma de pares
   for n=1 to nLen step 2
      s1:=s1+val(substr(cCode,n,1))
      s2:=s2+val(substr(cCode,n+1,1))
   next
   control:=(s1*3)+s2
   l:=10
   do while control>l
      l:=l+10
   end
   control:=l-control

   return str(Control,1,0)

// suplemento de 5 digitos
function _Sup5(cCode)
   local l, k, control, n, cBarras := '1011',nCar
   static parity:=[eeoooeoeooeooeoeoooeoeeooooeeooooeeoeoeooeooeooeoe]
   k:=left(alltrim(cCode)+'00000',5)             // padding with '0'
   control := right( str( val(substr(k,1,1))*3 + val(substr(k,3,1))*3 ;
      + val(substr(k,5,1))*3 + val(substr(k,2,1))*9+;
      val(substr(k,4,1))*9,5,0 ),1)
   control:=substr(primero,val(control)*6+2,5)
   for n:=1 to 5
      nCar:=val(substr(k,n,1))
      if substr(control,n,1)='o'
         cBarras+=substr(Izda2,nCar*7+1,7)
      else
         cBarras+=substr(Izda1,nCar*7+1,7)
      end
      if n<5
         cBarras+='01'
      end
   next
return cBarras
